<template>
    <div v-html="html"></div>
</template>

<script>
/* eslint-disable camelcase */
import DiffMatchPatch from 'diff-match-patch';
import { anyToString } from '@bloomio/spa-admin-common/utils';

export default {
    name: 'Diff',
    props: {
        /** the first (older) compared value */
        older: {
            type: null, // any type
            required: true,
        },
        /** the second (newer) compared value */
        newer: {
            type: null,
            required: true,
        },
        /** flag for diff displaying if values are identical */
        mode: {
            type: String,
            required: false,
            default: 'text', // text or status
        },
    },
    data() {
        return {
            dmp: null, // DiffMatchPatch
            html: '', // result html
        };
    },
    watch: {
        newer() {
            this.generateDiffHtml();
        },
    },
    created() {
        this.dmp = new DiffMatchPatch();
    },
    mounted() {
        this.generateDiffHtml();
    },
    methods: {
        /**
         * Calculation of diff options and generation of the result into html string
         */
        generateDiffHtml() {
            this.html = '';
            let haveChanges = false;
            const diffs = this.dmp.diff_main(anyToString(this.older), anyToString(this.newer));
            this.dmp.diff_cleanupSemantic(diffs);
            diffs.forEach((arr) => {
                const diff = arr;
                diff[1] = diff[1].replace(/\n/g, '<br/>');
                if (diff[0] === DiffMatchPatch.DIFF_EQUAL) {
                    this.html += `${diff[1]}`;
                }
                if (diff[0] === DiffMatchPatch.DIFF_DELETE) {
                    this.html += `<del class="removed">${diff[1]}</del>`;
                    haveChanges = true;
                }
                if (diff[0] === DiffMatchPatch.DIFF_INSERT) {
                    this.html += `<ins class="added">${diff[1]}</ins>`;
                    haveChanges = true;
                }
            });
            if (this.mode === 'status' && !haveChanges) {
                this.html = '';
            }
        },
    },
};
</script>

<style lang="stylus">
.added
    color: $base_green

.removed
    color: $base_red

</style>
